% Funktionsplan - SIMULINK Erweiterungs-Blockbibliothek.
% Version 3.1   April-2002
%
%
% Ausgewhlte Beispiele - siehe auch: >>>http://www.eti.et.tu-dresden.de/ae/ae_7_5.htm<<<
%                               bzw.  >>>http://www.eti.et.tu-dresden.de/ae/ae_7.htm<<<.
%   b1_avaz    - Einfache Alternativverzweigung.
%   b1a_avaz   - Alternativverzweigung mit Block ZE
%                (Allgemeiner Zustand mit Entkopplung).
%   b2_pvpz    - Einfache Parallelverzweigung.
%   b2a_pvpz   - Parallelverzweigung mit Block ZE
%                (Allgemeiner Zustand mit Entkopplung).
%   b2b        - Syntaxsonderfall: Parallelverzweigung ohne Ereignis.
%   b2c        - Einfaches Beispiel konform zur Syntax:
%                Parallelverzweigung und Alternativzusammenfhrung
%   b2d        - Syntaxsonderfall: Alternativverzweigung ohne Zustnde.
%   b3_ko1     - Verschachtelte Verzweigungen I: ohne Zustandssackgassen.
%   b3_ko2     - Verschachtelte Verzweigungen II:  1 Zustandssackgasse(2Z).
%   b3_ko3     - Verschachtelte Verzweigungen III: 1 Zustandssackgasse(4Z).
%   b3_ko4a    - Verschachtelte Verzweigungen IV:  6 Zustandssackgassen(2Z).
%   b3_ko4b    - Verschachtelte Verzweigungen V:   8 Zustandssackgassen(2Z).
%   b4_mkb2    - Einfache Anwendung des Kommentarblockes KB.
%   b5_mkb3g   - Zwei Stellantriebe nach DIN/VDE 3684; Gesamtsystem mit
%                einem Funktionsplan, zwei Antrieben und Zeitgebern.
%                (In 500ms treten ca. 9 Ereignisse auf;
%                 Sollwert_1=Beschleunigung; Sollwert_2=Drehzahl).
%   b6_mkb3e   - Wie b5_mkb3g, aber ohne Vorabschaltwerte fr Rckfahrt.
%   b7_efsm    - Stark vereinfachtes Teilmodell fr eine Schlauchbeutelmaschine;
%                Gesamtsystem mit Teilfunktionsplnen, drei Antrieben,
%                logischen Gleichungen fr Ereignisse und Sammelfehlerbehandlung.
%   b8_fvz     - Einfache verzweigte Fehlerbehandlung - Anwendung des FVZ-Blockes.
%
% Testbeispiele parallele FUP's
%   test01     - Zwei FUP's parallel (8 bzw. 4 Zustnde)
%   test02     - Zwei einfache FUP's parallel - ein FUP mit ZE- und FVZ-Block
%   test03     - Drei FUP's mit je zwei Zustnden parallel.
%   test03b    - Sechs FUP's mit je zwei Zustnden parallel.
%
% Testbeispiele Verschachtelungen in FUP's (bildschirmgerechte Aufteilung)
%   test08     - Ein linearer FUP mit vertikaler Verschachtelung in 6 Ebenen.
%   test09     - Ein FUP mit horizontalen und vertikalen Verschachtelungen.
%
% Testbeispiele zur Anwendung der ZF- und FVZ-Blcke 
%   test11     - Minimalbeispiel
%   test12     - FUP mit 8 Zustnden im Normalablauf
%
% Testbeispiele zur Anwendung der KB- und FUV-Blcke
%   test00     - Mini-FUP bei KB-Blcken mit Steuervariablen und Kommentaren
%                Nutzung des Anfangswertes fr den FUV-Block
%   test12a    - Unterschiedliche Anzahl von Steuervariablen in den KB-Blcken.

%   Copyright (c) 1997-2002 Dr. G.-H. Geitner, TU Dresden. All Rights Reserved.
%   Letzte nderung: 24.04.2002

