function [RM,QZN]=FUP_MFS01(Filename)
%function [RM,QZN]=FUP_MFS01(Filename)
%Fr Maschinenkodegenerierung FUP-Files mit Farbumschaltung erzeugen
%Typ 1: erstmaliger Einbau der Farbsteuerung in das File
%Typ 2: vorher wurde schon FUP_OFS auf das File angewendet
%Einschrnkungen: * Typ 1 - Fr Teilsystemmasken Ersteinstellung von
%                           Hand ntig (Blcke TE/TA; MaskInit: SN=gcb;)
%                 * Typ 1+2 - Handeintragung bei mehreren MaskInit-Fktnn
%                 * Typ 2 - Keine Leerzeichen-Editierung nach FUP_OFS
%                 * Achtung: Block 'MATLABfcn' ist nicht bersetzbar
% Filename - Name eines *.mdl Files mit einem Funktionsplan
% RM       - Vektor mit Rckmeldungen
% QZN      - Quellzeilennummer

T_00='Vor TKuE: File kann nicht ordnungsgem geschlossen werden!';
T_01='File existiert nicht!';
T_02='File kann nicht ordnungsgem geschlossen werden!';
T_03='FSEEK nach fgets liefert Fehler - Quellzeile:';
T_04='FPRINTF schreibt falsche Anzahl Bytes - Quellzeile:';
T_05='FSEEK nach fprintf liefert Fehler - Quellzeile:';
T_06='Vor TVuE: File kann nicht ordnungsgem geschlossen werden!';
T_07='Nach TVuE: FSEEK liefert Fehler';
T_08='Keine Einfgungsstelle fr Start/StopFcn!';
T_09='Nach TKuE: FSEEK liefert Fehler';

T_10='BrowserLookUnderMasks';
T_11='StartFcn'; T_11a='BF_Set4'; 
T_12='StopFcn';  T_12a='BF_Rue4'; 
T_13='System {';
T_14='MaskInitialization'; T_14a='SN=gcb;';
T_15='SourceBlock';
T_16a='T'; T_16c='/OA'; T_16d='/OE'; %  OA --> TA; OE --> TE
T_17='FUP_Plus/';
%    '"FUP_Plus/Z_"                   '
%    '"Funktionsplan/Funktionsplan/Z_"'
T_18='Funktionsplan/Funktionsplan'; %es fehlt noch: /+BN+"+13+10
T_19a='/ZA'; T_19b='/ZX'; T_19c='/ZE'; T_19d='/ZF';

fid=fopen([Filename '.mdl'],'rt+'); %File ffnen zum Lesen und Schreiben im Textmode
if fid==-1 error(T_01); end
[FiNa,Perm,MaFo]=fopen(fid); %Filename, Permission, Maschinenformat
QZN=0; RM(8)=0; Abbr=0; %RM(1) - MoProCb StartFcn fr FUP_Plus Erkennung
                        %  (2) - MoProCb StopFcn fe FUP_Plus Erkennung
                        %       1: Fcn leer erkannt / 0: Fcn neu eingefgt / -1: andere 
                        %  (3) >0 - Anz. eingefgter 'SN=gcb;' bei leerer MaskInit. 
                        %  (4) <0 - Anz. restlicher vorhandener MaskInit.
                        %  (5) >0 - Anz. SS-Farbabschalternamen in richtiger Bib. gef.
                        %  (6) <0 - Anz- SS-Farbabschalternamen in anderer Bib. gef.
                        %  (7) >0 - Anz. Zustands-Blocknamen in richtiger Bib. gef.
                        %  (8) <0 - Anz. Zustands-Blocknamen in anderer Bib. gef.

% *** Model Properties: CALLBACKS StartFcn "BF_Set4" / StopFcn "BF_Rue4" einfgen ***
%     Prfkriterium: leere Anweisung "       " ODER fehlende Fkt-Def.-Zeilen
while feof(fid)==0 & Abbr==0         %sicher;  ??? Typ 2 ??? 
      line=fgets(fid); QZN=QZN+1;    %Einlesen mit Zeilenwechselkode '10'
      if     findstr(line,T_11);
             j=length(T_11a); t='"'; t(2)=' ';  %leere Def. fr StartFcn
             t(3:j+1)=' '; t(j+2)='"';          %mit 'j' Leerzeichen erzeugen   
             x=findstr(line,t);                 %und suchen
             if x i=length(line);               %flexibel so
                  status=fseek(fid,x-i-1,0);    %Filepositionszeiger rckstellen (Byte)
                     if status error([T_03 num2str(QZN)]); end %NL + WR + " = 3 Zeichen
                  status=fprintf(fid,T_11a);    %Eintragung "   " --> "T_11a"
                     if status~=j error([T_04 num2str(QZN)]); end
                  status=fseek(fid,i-(x+j)+1,0);%Filepositionszeiger vor zum Ausggspkt.
                     if status error([T_05 num2str(QZN)]); end
                  RM(1)=1;                      %Operation protokollieren
             else RM(1)=-1; end                 %keine genaue StartFcn-T_11a-Platz Def.
      elseif findstr(line,T_12);
             j=length(T_12a); t='"'; t(2)=' ';  %leere Def. fr StopFcn
             t(3:j+1)=' '; t(j+2)='"';          %mit 'j' Leerzeichen erzeugen
             x=findstr(line,t);                 %und suchen
             if x i=length(line);               %flexibel so
                  status=fseek(fid,x-i-1,0);    %Filepositionszeiger rckstellen (Byte)
                     if status error([T_03 num2str(QZN)]); end %NL + WR + " = 3 Zeichen
                  status=fprintf(fid,T_12a);    %Eintragung "   " --> "T_12a"
                     if status~=j error([T_04 num2str(QZN)]); end
                  status=fseek(fid,i-(x+j)+1,0);%Filepositionszeiger vor zum Ausggspkt.
                     if status error([T_05 num2str(QZN)]); end
                  RM(2)=1;                      %Operation protokollieren
             else RM(2)=-1; end                 %keine genaue StopFcn-T_12a-Platz Def.
      elseif findstr(line,T_13); Abbr=1; end
end
frewind(fid);           %Filepositionszeiger zum Fileanfang
QZN=0; Abbr=0;
if ~RM(1)|~RM(2)        %??? Typ 1 ??? --> Zeile(n) fr Start/StopFcn fehlen
while Abbr==0 & feof(fid)==0      %sicher
   line=fgets(fid); QZN=QZN+1;    %Einlesen mit Zeilenwechselkode '10'
   if     findstr(line,T_10);     %Einfgungsstelle erreicht?
          if ~RM(1)               %Zeile fr StartFcn fehlt
             Pos=ftell(fid);      %aktuelle Position merken
             einf=['  StartFcn' char(09) char(09) '  "' T_11a '"' char(13) char(10)];
             VBA=length(einf);
             sta=fclose(fid);                   %Schlieen eines Files
             if sta==-1 error(T_06); end        %Status=0 i.O. ; =-1 Fehler
             TVuE01([Filename '.mdl'],Pos+1,VBA,einf);
             fid=fopen([Filename '.mdl'],'rt+');
             sta=fseek(fid,Pos+VBA,-1); %Korrektur Position File Indikator
             if sta error(T_07); end
             QZN=QZN+1;
          end
          if ~RM(2)               %Zeile fr StopFcn fehlt
             Pos=ftell(fid);      %aktuelle Position merken
             einf=['  StopFcn' char(09) char(09) '  "' T_12a '"' char(13) char(10)];
             VBA=length(einf);
             sta=fclose(fid);                   %Schlieen eines Files
             if sta==-1 error(T_06); end        %Status=0 i.O. ; =-1 Fehler
             TVuE01([Filename '.mdl'],Pos+1,VBA,einf);
             fid=fopen([Filename '.mdl'],'rt+');
             sta=fseek(fid,Pos+VBA,-1); %Korrektur Position File Indikator
             if sta error(T_07); end
             QZN=QZN+1;
          end
          Abbr=1;
   elseif findstr(line,T_13); error(T_08); end
end  
end
% *** Ende - Projekt-CALLBACKS einfgen ***

% *** Subsysteme: GCB einfgen, wenn leere Def. durch FUP_OFS vorhanden
%                 anderenfalls wre Kontext-Erkennung fr Teilsystem ntig
%     OE/OA: austauschen, wenn durch FUP_OFS schon eingefgt
%            anderenfalls wre Kontext-Erkennung u. Syntaxanalyse ntig
%     FUP: Zustandsblcke austauschen == Bibliothekswechsel ***
while feof(fid)==0
      line=fgets(fid); QZN=QZN+1;    %Einlesen mit Zeilenwechselkode '10'
      if     findstr(line,T_14);     %Subsystem MaskInitialization
             j=length(T_14a); t='"'; t(2)=' '; %leere Def. fr Pfadnamenerkennung   
             t(3:j+1)=' '; t(j+2)='"';         %mit 'j' Leerzeichen erzeugen
             x=findstr(line,t);                %und suchen
             if x i=length(line);              %flexibel so
                  status=fseek(fid,x-i-1,0);   %Filepositionszeiger rckstellen (Byte)
                     if status error([T_03 num2str(QZN)]); end%NL + WR + " = 3 Zeichen
                  status=fprintf(fid,T_14a);   %Pfadnamen-Erkennung einfgen
                     if status~=j error([T_04 num2str(QZN)]); end
                  status=fseek(fid,i-(x+j)+1,0);%Filepositionszeiger vor zum Ausggspkt.
                     if status error([T_05 num2str(QZN)]); end
                  RM(3)=RM(3)+1;                %Operation protokollieren
             else RM(4)=RM(4)-1; end
      elseif findstr(line,T_15);     %SourceBlock Namensuche
        x=findstr(line,'"');         %Namensvereinbarungsgrenzen suchen
        i=line(x(2)-3:x(2)-1);       %letzten drei ASCII-Zeichen laden
        switch i
          case {T_19a, T_19b, T_19c, T_19d} %Bib Pfad ndern fr: ZA/ZX/ZE/ZF
               if x(2)-x(1)-1==length(T_18)+length(i) & line(x(1)+1:x(1)+27)==T_18
                  RM(7)=RM(7)+1;             %Name in richtiger Bibliothek gefunden
                  PFI=ftell(fid);            %aktuelle Position merken
                  sta=fclose(fid);             %Schlieen eines Files
                  if sta ==-1 error(T_00); end %sta==0 i.O.; ==-1 Fehler
                  Pos=PFI-32;     %["FUP_Plus/Z*"'13''10']==15Z. --> Zeichen nach 1.'"'
                  KBA=19; %19 Zeichen zuviel - siehe Kommentar zw. T_17 und T_18
                  einf=[T_17 i(2:3) '"' char(13) char(10)]; %vollstndige Einfgung
                  TKuE01([Filename '.mdl'],Pos,KBA,einf);
                  fid=fopen([Filename '.mdl'],'rt+');
                  sta=fseek(fid,PFI-19,-1); %Korrektur Position File Indikator
                  if sta error(T_09); end
               else RM(8)=RM(8)-1; end      %Name in anderer Bibliothek gefunden
          case {T_16c, T_16d}               %OE/OA --> TE/TA , wenn schon vorhanden
              if x(2)-x(1)==length(T_17)+length(i) & line(x(1)+1:x(1)+9)==T_17%+1Z!
                 RM(5)=RM(5)+1;             %Name in richtiger Bibliothek gefunden
                 t=T_16a; j=length(t); 
                 status=fseek(fid,-(j+4),0);%Filepositionszeiger rckstellen (Byte)
                   if status error([T_03 num2str(QZN)]), end %NL + WR = 2 Zeichen
                 status=fprintf(fid,t);     %Zeilenende berschreiben
                   if status~=j error([T_04 num2str(QZN)]), end
                 status=fseek(fid,+4,0);    %Filepositionszeiger vor zum Ausggspkt.
                   if status error([T_05 num2str(QZN)]), end % "+NL+WR = 3 Zeichen
              else RM(6)=RM(6)-1; end         %Name in anderer Bibliothek gefunden
        end
      end
end
% *** Ende - Einfgen und Austauschen

status=fclose(fid);                   %Schlieen eines Files
if status==-1 error(T_02); end        %Status=0 i.O. ; =-1 Fehler
