function [RM,QZN]=FUP_OFS01(Filename)
%function [RM,QZN]=FUP_OFS01(Filename)
%Fr Maschinenkodegenerierung FUP-Files ohne Farbumschaltung erzeugen
%Grnde:   Block 'MATLABfcn' nicht bersetzbar
%          Laufzeitminimierung
% Filename - Name eines *.mdl Files mit einem Funktionsplan
% RM       - Vektor mit Rckmeldungen
% QZN      - Quellzeilennummer

T_01='File existiert nicht!';
T_02='File kann nicht ordnungsgem geschlossen werden!';
T_03='FSEEK nach fgets liefert Fehler - Quellzeile:';
T_04='FPRINTF schreibt falsche Anzahl Bytes - Quellzeile:';
T_05='FSEEK nach fprintf liefert Fehler - Quellzeile:';
T_06='Vor TVuE: File kann nicht ordnungsgem geschlossen werden!';
T_07='Nach TVuE: FSEEK liefert Fehler';

T_11='StartFcn'; T_11a='BF_Set4';
T_12='StopFcn';  T_12a='BF_Rue4';
T_13='System {';
T_14='MaskInitialization'; T_14a='SN=gcb;';
T_15='SourceBlock';
T_16a='/TE'; T_16b='/TA'; T_16c='O'; % TE --> OE; TA --> OA
T_17='FUP_Plus/';
%    '"FUP_Plus/Z_"                   '
%    '"Funktionsplan/Funktionsplan/Z_"'
T_18='Funktionsplan/Funktionsplan'; %es fehlt noch: /+BN+"+13+10
T_19a='/ZA'; T_19b='/ZX'; T_19c='/ZE'; T_19d='/ZF';

fid=fopen([Filename '.mdl'],'rt+'); %File ffnen zum Lesen und Schreiben im Textmode
if fid==-1 error(T_01); end
[FiNa,Perm,MaFo]=fopen(fid); %Filename, Permission, Maschinenformat
QZN=0; RM(8)=0; Abbr=0; %RM(1) - MoProCb StartFcn fr FUP_Plus Erkennung
                        %  (2) - MoProCb StopFcn fe FUP_Plus Erkennung
                        %       1: Fcn erkannt / -1: andere Fcn erkannt / 0: keine Fcn 
                        %  (3) >0 - Anz. entfernter MaskInit. 'SN=gcb;'
                        %  (4) <0 - Anz. nicht entfernter MaskInit.
                        %  (5) >0 - Anz. SS-Farbschalternamen in richtiger Bib. gef.
                        %  (6) <0 - Anz- SS-Farbschalternamen in anderer Bib. gef.
                        %  (7) >0 - Anz. Zustands-Blocknamen in richtiger Bib. gef.
                        %  (8) <0 - Anz. Zustands-Blocknamen in anderer Bib. gef.

% *** Model Properties: CALLBACKS StartFcn "BF_Set4" / StopFcn "BF_Rue4" entfernen ***
%     Ergebnis: leere Zeilen
while feof(fid)==0 & Abbr==0
      line=fgets(fid); QZN=QZN+1;    %Einlesen mit Zeilenwechselkode '10'
      if     findstr(line,T_11);
             x=findstr(line,T_11a);
             if x i=length(line); j=length(T_11a); %flexibel so
                  t=' '; t(2:j)=' ';            %StartFcn "T_11" lschen
                  status=fseek(fid,x-i-2,0);    %Filepositionszeiger rckstellen (Byte)
                     if status error([T_03 num2str(QZN)]); end %NL + WR = 2 Zeichen
                  status=fprintf(fid,t);        %Zeile teilweise berschreiben --> "  "
                     if status~=j error([T_04 num2str(QZN)]); end
                  status=fseek(fid,i-(x+j)+2,0);%Filepositionszeiger vor zum Ausggspkt.
                     if status error([T_05 num2str(QZN)]); end
                  RM(1)=1;                      %Operation protokollieren
             else RM(1)=-1; end
      elseif findstr(line,T_12);
             x=findstr(line,T_12a);
             if x i=length(line); j=length(T_12a); %flexibel so
                  t=' '; t(2:j)=' ';            %StopFcn "T_12" lschen
                  status=fseek(fid,x-i-2,0);    %Filepositionszeiger rckstellen (Byte)
                     if status error([T_03 num2str(QZN)]); end %NL + WR = 2 Zeichen
                  status=fprintf(fid,t);        %Zeile teilweise berschreiben --> "  "
                     if status~=j error([T_04 num2str(QZN)]); end
                  status=fseek(fid,i-(x+j)+2,0);%Filepositionszeiger vor zum Ausggspkt.
                     if status error([T_05 num2str(QZN)]); end
                  RM(2)=1;                      %Operation protokollieren
             else RM(2)=-1; end
      elseif findstr(line,T_13); Abbr=1; end
end
% *** Ende - CALLBACKS entfernen ***

% *** Subsysteme: GCB entfernen, TE/TA austauschen; FUP: Zustandsblcke austauschen ***
while feof(fid)==0
      line=fgets(fid); QZN=QZN+1;    %Einlesen mit Zeilenwechselkode '10'
      if     findstr(line,T_14);     %Subsystem MaskInitialization
             x=findstr(line,T_14a);
             if x i=length(line); j=length(T_14a); %flexibel so
                  t=' '; t(2:j)=' ';            %Pfadnamen-Erkennung lschen
                  status=fseek(fid,x-i-2,0);    %Filepositionszeiger rckstellen (Byte)
                     if status error([T_03 num2str(QZN)]); end %NL + WR = 2 Zeichen
                  status=fprintf(fid,t);        %Zeile teilweise berschreiben --> "  "
                     if status~=j error([T_04 num2str(QZN)]); end
                  status=fseek(fid,i-(x+j)+2,0);%Filepositionszeiger vor zum Ausggspkt.
                     if status error([T_05 num2str(QZN)]); end
                  RM(3)=RM(3)+1;                %Operation protokollieren
             else RM(4)=RM(4)-1; end
      elseif findstr(line,T_15);     %SourceBlock Namensuche
        x=findstr(line,'"');         %Namensvereinbarungsgrenzen suchen
        i=line(x(2)-3:x(2)-1);       %letzten drei ASCII-Zeichen laden
        switch i
          case {T_19a, T_19b, T_19c, T_19d} %Bib Pfad ndern fr: ZA/ZX/ZE/ZF
               if x(2)-x(1)==length(T_17)+length(i) & line(x(1)+1:x(1)+9)==T_17%+1Z!
                  RM(7)=RM(7)+1;             %Name in richtiger Bibliothek gefunden
                  PFI=ftell(fid);               %aktuelle Position merken
                  status=fclose(fid);                   %Schlieen eines Files
                  if status==-1 error(T_06); end        %Status=0 i.O. ; =-1 Fehler
                  Pos=PFI-13;     %["FUP_Plus/Z*"'13''10']==15Z. --> Zeichen nach 1.'"'
                  VBA=19; %Es fehlen 19 Zeichen - siehe Kommentar zw. T_17 und T_18
                  einf=[T_18 i '"' char(13) char(10)]; %vollstndige Einfgung
                  TVuE01([Filename '.mdl'],Pos,VBA,einf);
                  fid=fopen([Filename '.mdl'],'rt+');
                  status=fseek(fid,PFI+19,-1); %Korrektur Position File Indikator
                  if status error(T_07); end
               else RM(8)=RM(8)-1; end         %Name in anderer Bibliothek gefunden
          case {T_16a, T_16b}               %TE/TA --> OE/OA
              if x(2)-x(1)==length(T_17)+length(i) & line(x(1)+1:x(1)+9)==T_17%+1Z!
                 RM(5)=RM(5)+1;             %Name in richtiger Bibliothek gefunden
                 t=T_16c; j=length(t); 
                 status=fseek(fid,-(j+4),0);%Filepositionszeiger rckstellen (Byte)
                   if status error([T_03 num2str(QZN)]), end %NL + WR = 2 Zeichen
                 status=fprintf(fid,t);     %Zeilenende berschreiben
                   if status~=j error([T_04 num2str(QZN)]), end
                 status=fseek(fid,+4,0);    %Filepositionszeiger vor zum Ausggspkt.
                   if status error([T_05 num2str(QZN)]), end % "+NL+WR = 3 Zeichen
              else RM(6)=RM(6)-1; end         %Name in anderer Bibliothek gefunden
        end
      end
end
% *** Ende - Entfernen und Austauschen

status=fclose(fid);                   %Schlieen eines Files
if status==-1 error(T_02); end        %Status=0 i.O. ; =-1 Fehler
